module limiter
  use const_and_precisions, only : wp_
  ! === 1D array limiter Rlim_i, Zlim_i
  integer, public, save :: nlim
  real(wp_), save :: rwallm
  real(wp_), dimension(:), allocatable, save :: rlim,zlim
  
contains

  subroutine set_lim(rv,zv)
    implicit none
    real(wp_), intent(in), dimension(:) :: rv,zv
    if (allocated(rlim)) deallocate(rlim)
    if (allocated(zlim)) deallocate(zlim)
    nlim=size(rv)
    allocate(rlim(nlim),zlim(nlim))
    rlim=rv
    zlim=zv
    rwallm=minval(rlim)
  end subroutine set_lim



  subroutine unset_lim
    use const_and_precisions, only : zero
    implicit none
    if(allocated(rlim))   deallocate(rlim)
    if(allocated(zlim))   deallocate(zlim)
    nlim=0
    rwallm=zero
  end subroutine unset_lim

end module limiter